<?php

/**
 * Yii uploader
 *
 * @author Marc Oliveras Galvez <oligalma@gmail.com> 
 * @link http://www.oligalma.com
 * @copyright 2016 Oligalma
 * @license New BSD License
 */
 
class UploaderModule extends CWebModule{
	/*
	 * Add parameters here. You can access them using Yii::app()->controller->module->myParameter
	 */
	public $db;
    public $defaultController ="Image";
	private $_assetsUrl;
	
    public function init()
    {
        $this->setImport(array(
                'uploader.models.*',
        ));
		
        Yii::app()->setComponents(
        	array(
		       'db'=>array(
		           'class'=>'CDbConnection',
		           'tablePrefix' => 'tbl_',
		           'connectionString'=>'sqlite:'.dirname(__FILE__).'/data/uploader.sqlite',
		       ),
			)
		);        
    }
	
	public function getAssetsUrl()
	{        
	    if ($this->_assetsUrl === null)
	        $this->_assetsUrl = Yii::app()->getAssetManager()->publish(Yii::getPathOfAlias('uploader.assets'));
		
	    return $this->_assetsUrl;
	}
}