<?php
/**
 * Yii uploader
 *
 * @author Marc Oliveras Galvez <oligalma@gmail.com> 
 * @link http://www.oligalma.com
 * @copyright 2016 Oligalma
 * @license New BSD License
 */
 
class ImageController extends CController
{
	public $layout = '//layouts/column1';

    public function actionIndex()
    {        
        $folders = Image::getFolders();
        
        if(isset($_POST['folder']))
            $folder = $_POST['folder'];
        elseif(isset($_GET['folder']))
        {
            $folder = $_GET['folder'];
            if(strlen($folder) == 0)
                $folder = '.';
        }
        else
            $folder = reset($folders);
                
        $images = Image::model()->findAll(array('condition' => 'folder = :folder','order' => 'ordering', 'params' => array(':folder' => $folder)));
        $image = Image::model()->find(array('select' => 'MAX(id) as maxId'));
        $this->render('index', array('images' => $images, 'nextId' => $image->maxId + 1, 'folders' => $folders, 'folder' => $folder));
    }
    	
	public function actionUpdate()
	{
        $folder = $_POST['folder'];
        if(strlen($folder) == 0)
            $folder = '.';
        $path = 'images/' . $folder . '/';
                   
        foreach($_POST as $key => $value)
        {            
            if(substr($key, 0, 6) === 'delete')
            {
                $code = substr($key,6);
                $delete = $_POST['delete' . $code];

                $image = Image::model()->findByPk($code);
                if($image != null)
                {
                    if(file_exists($path . $image->file))
                    {
                        unlink($path . $image->file);
                    }
                }
                
                Image::model()->deleteAll(array('condition' => 'id = :code', 'params' => array(':code' => $code)));
            }
        }
                
        foreach($_POST as $key => $value)
        {
            if(substr($key, 0, 8) === 'ordering')
            {
                $code = substr($key,8);
                $ordering = $_POST['ordering' . $code];
                if(!is_numeric($ordering))
                {
                    $ordering = 0;
                }

                $image = Image::model()->findByPk($code);
                if($image != null)
                {
                    $image->ordering = $ordering;
                    $image->save();
                }
            }
            
            if(substr($key, 0, 4) === 'name')
            {
                $code = substr($key,4);          
                $name = $_POST['name' . $code];
                $image = Image::model()->findByPk($code);               
                if($image != null)
                {
                    $image->name = $name;
                    $image->save();
                }
            }
                      
            if(substr($key, 0, 11) === 'description')
            {
                $code = substr($key,11);
                $description = $_POST['description' . $code];
                $image = Image::model()->findByPk($code);             
                if($image != null)
                {
                    $image->description = $description;
                    $image->save();
                }
            }
        }
        
        foreach($_FILES as $key => $value)
        {
            if($value['name'] != '' && ($value['type'] == 'image/jpeg' || $value['type'] == 'image/png' || $value['type'] == 'image/gif'))
            {
                $code = substr($key,5);
                $ordering = $_POST['ordering' . $code];
                $name = $_POST['name' . $code];
                $description = $_POST['description' . $code];
               
                if(!is_numeric($ordering))
                {
                    $ordering = 0;
                }
             
                $image = Image::model()->findByPk($code);
                
                if($image != null) // update
                {
                    if(file_exists($path . $image->file))
                        unlink($path . $image->file);
                }
                else // insert
                {
                    $image = new Image;
                    $image->id = $code;
                    $image->folder = $folder;
                }
                
                $extension = '';
                switch($value['type'])
                {
                    case 'image/jpeg':
                        $extension = 'jpg';
                        break;
                    case 'image/png':
                        $extension = 'png';
                        break;
                    case 'image/gif':
                        $extension = 'gif';
                        break;
                }
                
                $image->file = $code . '.' . $extension;
                $image->ordering = $ordering;
                $image->name = $name;
                $image->description = $description;
                $image->save();
                                   
                move_uploaded_file($value['tmp_name'],$path . $code . '.' . $extension);
                //chmod($path . $file, 755);
            }
        }

        $this->redirect(array('index', 'folder' => $folder));
	}
}
