<?php
/**
 * Yii uploader
 *
 * @author Marc Oliveras Galvez <oligalma@gmail.com> 
 * @link http://www.oligalma.com
 * @copyright 2016 Oligalma
 * @license New BSD License
 */
 
class Image extends CActiveRecord
{
    const EXCLUDE_ROOT_IMAGE_DIRECTORY = true;	
	public $maxId = 0;

	/**
	 * Returns the static model of the specified AR class.
	 * @return CActiveRecord the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return '{{image}}';
	}
	
	public static function getFolders()
	{
		$files = scandir('images');
		foreach ($files as $key => $value) {
		    if (($value === '.' && self::EXCLUDE_ROOT_IMAGE_DIRECTORY) or $value === '..' or !is_dir('images/' . $value))
				unset($files[$key]);
		}
		$files = array_combine($files, $files);
		return $files;
	}
}
